import torch

from agent import Actor, Critic, Policy
from env.env import create_RSMTEnv
import gym

import pdb

batch_size = 4
num_nodes = 8
max_episode_num = 40000 # 40k

pos_l = 0.0
pos_h = 100.0

env_fns = [lambda: create_RSMTEnv(num_nodes=num_nodes, 
                                  pos_l=pos_l, 
                                  pos_h=pos_h)
           for i in range (batch_size)
          ]
envs = gym.vector.AsyncVectorEnv(env_fns)
pdb.set_trace()

actor_net = Actor()
critic_net = Critic()
model = Policy(actor=actor_net, 
               critic=critic_net, 
              )

nodes_xy, mask_visited = envs.reset()
for episode in range(max_episode_num):
  for i in range(num_nodes):
    if i == 0:
      u0 = model.first_act(nodes_xy)
      mask_visited, rewards, done, _ = envs.step(u0)
      continue
    v, h = model.act(nodes_xy, mask_visited=mask_visited)
    # v/h is a tensor of shape [#batch_size] on model.device
    mask_visited, rewards, done, _ = envs.step(v, h)
    if done:
      model.learn(nodes_xy, rewards)
      nodes_xy, mask_visited = envs.reset()
    
